#!/usr/bin/perl

use strict;
use warnings;

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ConfigurationManagement.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"RetrieveKeysList"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => '')->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('RetrieveContactKeysList', $model);

if ($som->fault) {
    my $code = $som->faultcode;
    my $actor = $som->faultactor;
    my $string = $som->faultstring;
    my $detail = $som->faultdetail;
    my $out = "Fault\n";
    $out .= "\tCode\t$code\n" if ($code);
    $out .= "\tActor\t$actor\n" if ($actor);
    $out .= "\tString\t$string\n" if ($string);
    $out .= "\tDetail\t$detail\n" if ($detail);
    die $out;
}

soapdata($som, '//RetrieveContactKeysListResponse/keys', 1);
soapdata($som, '//RetrieveContactKeysListResponse/model', 0);
soapdata($som, '//RetrieveContactKeysListResponse/messages', 1);
